## firebird3.0 3.0.2.32703.ds4

=== extern/cloop/Makefile ===
MODULES	:= cloop tests tests/test1

WITH_FPC	:= 1

TARGET	:= release

CC	:= gcc
CXX	:= g++
LD	:= $(CXX)

SRC_DIR		:= src
BUILD_DIR	:= build
OUT_DIR		:= output
SHRLIB_EXT	:= .so
EXE_EXT		:=

OBJ_DIR := $(BUILD_DIR)/$(TARGET)
BIN_DIR := $(OUT_DIR)/$(TARGET)/bin
LIB_DIR := $(OUT_DIR)/$(TARGET)/lib

SRC_DIRS := $(addprefix $(SRC_DIR)/,$(MODULES))
OBJ_DIRS := $(addprefix $(OBJ_DIR)/,$(MODULES))

SRCS_C := $(foreach sdir,$(SRC_DIRS),$(wildcard $(sdir)/*.c))
SRCS_CPP := $(foreach sdir,$(SRC_DIRS),$(wildcard $(sdir)/*.cpp))

OBJS_C := $(patsubst $(SRC_DIR)/%.c,$(OBJ_DIR)/%.o,$(SRCS_C))
OBJS_CPP := $(patsubst $(SRC_DIR)/%.cpp,$(OBJ_DIR)/%.o,$(SRCS_CPP))

C_FLAGS := -ggdb -fPIC -MMD -MP -W -Wall -Wno-unused-parameter
CXX_FLAGS := $(C_FLAGS)
FPC_FLAGS := -Mdelphi

ifeq ($(TARGET),release)
	CXX_FLAGS += -O3
endif

ifeq ($(TARGET),debug)
	FPC_FLAGS += -g
endif

vpath %.c $(SRC_DIRS)
vpath %.cpp $(SRC_DIRS)

define compile
$1/%.o: %.c
	$(CC) -c $$(C_FLAGS) $$< -o $$@

$1/%.o: %.cpp
	$(CXX) -c $$(CXX_FLAGS) $$< -o $$@
endef

.PHONY: all mkdirs clean

all: mkdirs \
	$(BIN_DIR)/cloop	\
	$(BIN_DIR)/test1-c$(SHRLIB_EXT)	\
	$(BIN_DIR)/test1-c$(EXE_EXT)	\
	$(BIN_DIR)/test1-cpp$(SHRLIB_EXT)	\
	$(BIN_DIR)/test1-cpp$(EXE_EXT)	\
	$(BIN_DIR)/test1-pascal$(SHRLIB_EXT)	\
	$(BIN_DIR)/test1-pascal$(EXE_EXT)

mkdirs: $(OBJ_DIRS) $(BIN_DIR) $(LIB_DIR)

$(OBJ_DIRS) $(BIN_DIR) $(LIB_DIR):
	@mkdir -p $@

clean:
	@rm -rf $(BUILD_DIR) $(OUT_DIR)

$(foreach bdir,$(OBJ_DIRS),$(eval $(call compile,$(bdir))))

-include $(addsuffix .d,$(basename $(OBJS_C)))
-include $(addsuffix .d,$(basename $(OBJS_CPP)))

$(BIN_DIR)/cloop: \
	$(OBJ_DIR)/cloop/Expr.o \
	$(OBJ_DIR)/cloop/Generator.o \
	$(OBJ_DIR)/cloop/Lexer.o \
	$(OBJ_DIR)/cloop/Parser.o \
	$(OBJ_DIR)/cloop/Main.o \

	$(LD) $^ -o $@

$(SRC_DIR)/tests/test1/CalcCApi.h: $(BIN_DIR)/cloop $(SRC_DIR)/tests/test1/Interface.idl
	$(BIN_DIR)/cloop $(SRC_DIR)/tests/test1/Interface.idl c-header $@ CALC_C_API_H CALC_I

$(SRC_DIR)/tests/test1/CalcCApi.c: $(BIN_DIR)/cloop $(SRC_DIR)/tests/test1/Interface.idl $(SRC_DIR)/tests/test1/CalcCApi.h
	$(BIN_DIR)/cloop $(SRC_DIR)/tests/test1/Interface.idl c-impl $@ CalcCApi.h CALC_I

$(SRC_DIR)/tests/test1/CalcCppApi.h: $(BIN_DIR)/cloop $(SRC_DIR)/tests/test1/Interface.idl
	$(BIN_DIR)/cloop $(SRC_DIR)/tests/test1/Interface.idl c++ $@ CALC_CPP_API_H calc I

$(SRC_DIR)/tests/test1/CalcPascalApi.pas: $(BIN_DIR)/cloop \
	$(SRC_DIR)/tests/test1/Interface.idl \
	$(SRC_DIR)/tests/test1/CalcPascalApi.interface.pas \
	$(SRC_DIR)/tests/test1/CalcPascalApi.implementation.pas
	$(BIN_DIR)/cloop $(SRC_DIR)/tests/test1/Interface.idl pascal $@ CalcPascalApi \
		--uses "SysUtils" \
		--interfaceFile $(SRC_DIR)/tests/test1/CalcPascalApi.interface.pas \
		--implementationFile $(SRC_DIR)/tests/test1/CalcPascalApi.implementation.pas \
		--exceptionClass CalcException

$(SRC_DIR)/tests/test1/CppTest.cpp: $(SRC_DIR)/tests/test1/CalcCppApi.h

$(BIN_DIR)/test1-c$(SHRLIB_EXT): \
	$(OBJ_DIR)/tests/test1/CalcCApi.o \
	$(OBJ_DIR)/tests/test1/CTest.o \

	$(LD) $^ -shared -ldl -o $@

$(BIN_DIR)/test1-c$(EXE_EXT): \
	$(OBJ_DIR)/tests/test1/CalcCApi.o \
	$(OBJ_DIR)/tests/test1/CTest.o \

	$(LD) $^ -ldl -o $@

$(BIN_DIR)/test1-cpp$(SHRLIB_EXT): \
	$(OBJ_DIR)/tests/test1/CppTest.o \

	$(LD) $^ -shared -ldl -o $@

$(BIN_DIR)/test1-cpp$(EXE_EXT): \
	$(OBJ_DIR)/tests/test1/CppTest.o \

	$(LD) $^ -ldl -o $@

$(BIN_DIR)/test1-pascal$(SHRLIB_EXT): \
	$(SRC_DIR)/tests/test1/PascalClasses.pas \
	$(SRC_DIR)/tests/test1/PascalLibrary.dpr \
	$(SRC_DIR)/tests/test1/CalcPascalApi.pas \

ifeq ($(WITH_FPC),1)
	fpc $(FPC_FLAGS) -fPIC -FU$(OBJ_DIR)/tests/test1 -o$(BIN_DIR)/test1-pascal$(SHRLIB_EXT) $(SRC_DIR)/tests/test1/PascalLibrary.dpr
endif

$(BIN_DIR)/test1-pascal$(EXE_EXT): \
	$(SRC_DIR)/tests/test1/PascalClasses.pas \
	$(SRC_DIR)/tests/test1/PascalTest.dpr \
	$(SRC_DIR)/tests/test1/CalcPascalApi.pas \

ifeq ($(WITH_FPC),1)
	fpc $(FPC_FLAGS) -FU$(OBJ_DIR)/tests/test1 -o$(BIN_DIR)/test1-pascal$(EXE_EXT) $(SRC_DIR)/tests/test1/PascalTest.dpr
endif

## firebird3.0 3.0.0~svn+53030.ds3

=== debian/changelog ===
firebird3.0 (3.0.0~svn+53030.ds3-1) experimental; urgency=low

  * New upstream SVN snapshot

  * drop unused patches (kfreebsd fix and nice compiler messages)
  * update copyright summary
  * refresh no-binary-gbaks.patch to apply cleanly
  * describe two new symbols in libfbclient2

 -- Damyan Ivanov <dmn@debian.org>  Sun, 29 May 2011 13:03:07 +0300

firebird3.0 (3.0.0~svn+52872.ds3-1) experimental; urgency=low

  * New upsream SVN snapshot

  * patchworks:
    + rework semaphore permissions patch
    + dtop trim-cflags.patch (applied upstream)
    + disable fix_kfreebsd_amd64_miscompile.patch
    + no-spurious-linkage.patch: -ldl only where needed
    + added out/no-copy-from-icu.patch removing emnedded ICU code from isql
      linking instead
  * pack-upstream-snapshot: drop date from version
  * tighten firebird-dev dependency on libib-util
  * update copyright summary
  * move libfbintl.so from -common to -server
    Avoids circular dependency between libfbclient2 and -common. Thanks,
    lintian!
  * -common is now Arch:all
  * drop Conflicts with ancient firebird2-* packages
  * add Conflicts with still current -server-common and -common packages
  * Claim conformance with Policy 3.9.2

 -- Damyan Ivanov <dmn@debian.org>  Wed, 04 May 2011 21:50:56 +0300

firebird3.0 (3.0.0~svn20110323r52594.ds3-1) experimental; urgency=low

  * New upstream SVN snapshot

  * update copyright/licensing summary
  * patchworks:
    + drop s390_targets.patch
    + adapt/refresh the rest
    + disale nice-compiler-msg.patch
  * make_packages: do not create empty usr/lib/firebird/3.0/lib directory in
    -server. thanks, lintian

 -- Damyan Ivanov <dmn@debian.org>  Wed, 23 Mar 2011 23:01:25 +0200

firebird3.0 (3.0.0~svn20110213r52346.ds3-1) experimental; urgency=low

  * New upstream SVN snapshot

  * remove alternative dependency on cdebconf it is priority:extra and
    we want to stay priority:optional

 -- Damyan Ivanov <dmn@debian.org>  Sun, 13 Feb 2011 16:18:39 +0200

firebird3.0 (3.0.0~svn20110113r52113.ds3-1) experimental; urgency=low

  * New upsream SVN snapshot

  * copyright: drop three files gone upstream

 -- Damyan Ivanov <dmn@debian.org>  Fri, 14 Jan 2011 11:02:58 +0200

firebird3.0 (3.0.0~svn20101218r52055.ds3-1) experimental; urgency=low

  * New upstream SVN snapshot

  * make nice-compiler-msg.patch a bit less intrusive
  * out/s390_targets.patch is forwarded
  * no-binary-metadata.gbak.patch is forwarded

 -- Damyan Ivanov <dmn@debian.org>  Sat, 18 Dec 2010 21:21:38 +0200

firebird3.0 (3.0.0~svn20101206r52030.ds3-1) experimental; urgency=low

  * New upstream SVN snapshot

  * move s390_targets.patch to out/
  * remove mention of using packaged ICU
  * copyright: drop a couple of files removed upstream
  * refresh patches to apply cleanly

 -- Damyan Ivanov <dmn@debian.org>  Sun, 12 Dec 2010 17:19:45 +0200

firebird3.0 (3.0.0~svn20101120r51946.ds3-1) experimental; urgency=low

  * New upstream SVN snapshot

  * patches:
    + series: drop (commented) references to dropped patches
    + split no-binary-metadata.gbak.patch out of no-binary-gbaks.patch. It
      could be forwarded upstream
    + drop out/customizable-log-filename.patch; applied upstream
    + one hunk from no-spurious-linkage.patch applied upstream
  * control: fix bad punctiation in -server description
  * control: do not refer to non-existing -superclassic in -common-doc
    description

 -- Damyan Ivanov <dmn@debian.org>  Sat, 20 Nov 2010 16:57:59 +0200

firebird3.0 (3.0.0~svn20101108r51857.ds3-1) experimental; urgency=low

  * New upstream SVN snapshot
  * drop default-rpath.patch; applied upstream
  * re-enable nice-compiler-msg.patch
  * try to streamline nice-compiler-msg.patch
  * prune README.Debian: there are no static libraries anymore
  * prune README.Debian: SQLDA_DISPLAY isql option is available upstream
  * rules: drop useless --disable-static
  * drop unused link_atomic_ops.patch
  * drop unused no-static-linkage.patch
  * remove $(THR_LIBS) from no-spurious-linkage.patch
  * improve comments in libib-util lintian override
  * drop unussed firebird-utils.{manpages,wrapper}
  * drop obsolete superclassic.lintian-overrides
  * rename .xinetd file and improve comments

 -- Damyan Ivanov <dmn@debian.org>  Mon, 08 Nov 2010 16:19:31 +0200

firebird3.0 (3.0.0~svn20101025r51765.ds3-1) experimental; urgency=low

  * Initial upload of Firebird 3.0, based on firebird2.5
    Closes: #600460 (ITP)

  * prune 2.5 changelog entries
  * watch: track 3.0 releases, prereleases and snapshots
  * repack.sh: adapt to 3.0
  * package simplified thanks to upstream unifying architectures. We now have a
    single -server package and a separate -utils one (see #568089)
  * fbstat manual page rewritten in POD
  * reorganize patches; forward some upstream
  * control: I am the only uploader (since a loong time)
  * remove any references to gdef (gone upstream)
  * libfbclient2.symbols: tag internal symbols as (optional)
  * improved debian/copyright_check.pl
  * update debian/copyright; no surprises
  * debian/pack-upstream-snapshot.sh -- a new script for packaging upstream
    snapshots
  * -server.postrm: delete password database unconditionally on purge
  * control: drop Conflicts/Provices: firebird-udf
  * debian/repack.sh: remove binary .gbak files
  * add no-binary-gbak.patch -- builds metadata.fdb from src/dbs/metadata.sql
    and removes qli and help.fdb from the build (because of missing source of
    help.fdb)

 -- Damyan Ivanov <dmn@debian.org>  Mon, 25 Oct 2010 17:21:43 +0300

=== debian/control ===
Source: firebird3.0
Section: database
Priority: optional
Maintainer: Debian Firebird Group <pkg-firebird-general@lists.alioth.debian.org>
Uploaders: Damyan Ivanov <dmn@debian.org>
Build-Depends: 
 autoconf,
 automake,
 bison,
 debhelper (>= 7),
 docbook-to-man,
 gawk,
 libatomic-ops-dev (>= 1.2+cvs20091005),
 libedit-dev,
 libicu-dev,
 libtool,
 po-debconf
Build-Conflicts: autoconf2.13, automake1.4
Standards-Version: 3.9.2
Vcs-Git: git://git.debian.org/git/pkg-firebird/3.0.git
Vcs-Browser: http://git.debian.org/?p=pkg-firebird/3.0.git;a=summary
Homepage: http://firebirdsql.org/

Package: firebird3.0-server
Architecture: any
Provides: firebird-server
Conflicts: firebird-server,
 firebird2.5-server-common,
 firebird2.1-super, firebird2.1-classic, firebird2.1-server-common,
 firebird2.0-classic, firebird2.0-super, firebird2.0-server-common
Depends: adduser, ${shlibs:Depends}, firebird3.0-common (= ${source:Version}),
 firebird3.0-utils (= ${binary:Version}),
 lsb-base, ${misc:Depends}, debconf (>= 1.4.69),
 firebird3.0-common-doc (= ${source:Version})
Recommends: libib-util
Suggests: firebird3.0-doc
Description: Firebird Server - an RDBMS based on InterBase 6.0 code
 Firebird is a relational database offering many ANSI SQL-99 features that
 runs on Linux, Windows, and a variety of Unix platforms. Firebird offers
 excellent concurrency, high performance, and powerful language support
 for stored procedures and triggers. It has been used on production systems
 under a variety of names since 1981.
 .
 This package contains the server binary as well as its configuration files.
 The default mode of operation is the so called "superclassic", which is a
 multi-threaded server -- each connection starts a separate thread and each
 connection has its own page cache. The two other operation modes -- "classic"
 (separate process/cache for each connection; started from the internet
 super-server inetd or xinetd) and "super" (single-threaded server process with
 shared cache beteen connections) are also available via configuration options.
 .
 This package contains the 3.0 branch of Firebird and is meant for the
 experimental Debian distribution, due to the high pace of ongoing upstream
 development. Its goal is to provide easy testing of the new features of
 Firebird and to have early exposure of the packaging helping to discover any
 problems.
 .
 Be aware that the ODS (on-disk structure) hasn't been finalized yet, so
 databases could be incompatible between different package versions and you'll
 have to either recreate them or migrate them via backup/restore.

Package: firebird3.0-utils
Architecture: any
Provides: firebird-utils
Conflicts: firebird-utils, firebird2.5-common,
 firebird2.1-super, firebird2.1-classic, firebird2.1-common,
 firebird2.0-classic, firebird2.0-super, firebird2.0-common
Depends: ${shlibs:Depends}, firebird3.0-common (= ${source:Version}),
 ${misc:Depends}, 
 firebird3.0-common-doc (= ${source:Version})
Suggests: firebird3.0-doc
Description: Firebird user utilities
 Firebird is a relational database offering many ANSI SQL-99 features that
 runs on Linux, Windows, and a variety of Unix platforms. Firebird offers
 excellent concurrency, high performance, and powerful language support
 for stored procedures and triggers. It has been used on production systems
 under a variety of names since 1981.
 .
 This package contains the utilities for managing firebird servers:
  * isql-fb -- interactive console (original name isql)
  * gbak -- backup and restore databases
  * gfix -- check and repair databases
  * gsec -- manage users and roles
  * fbstat -- analyze databases (original name gstat)
  * nbackup -- incremental backup and file-level copy
  * gpre -- preprocess sources with embedded SQL

Package: libfbclient2
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, firebird3.0-common (= ${source:Version}),
 ${misc:Depends},
 firebird3.0-common-doc (= ${source:Version})
Description: Firebird client library
 Firebird is a relational database offering many ANSI SQL-99 features that
 runs on Linux, Windows, and a variety of Unix platforms. Firebird offers
 excellent concurrency, high performance, and powerful language support
 for stored procedures and triggers. It has been used on production systems
 under a variety of names since 1981.
 .
 This package contains the client library required to connect to Firebird. It
 works with Firebird and commercial InterBase servers.
 .
 It uses TCP to connect to remote databases and file-level access for local
 databases.

Package: libib-util
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 firebird3.0-common-doc (= ${source:Version})
Description: Firebird UDF support library
 Firebird is a relational database offering many ANSI SQL-99 features that
 runs on Linux, Windows, and a variety of Unix platforms. Firebird offers
 excellent concurrency, high performance, and powerful language support
 for stored procedures and triggers. It has been used on production systems
 under a variety of names since 1981.
 .
 libib_util contains utility functions used by User-Defined Functions (UDF) for
 memory management etc.

Package: firebird3.0-common
Architecture: all
Depends: ${misc:Depends},
 firebird3.0-common-doc (= ${source:Version})
Description: common files for firebird 3.0 server, client and utilities
 Firebird is a relational database offering many ANSI SQL-99 features that
 runs on Linux, Windows, and a variety of Unix platforms. Firebird offers
 excellent concurrency, high performance, and powerful language support
 for stored procedures and triggers. It has been used on production systems
 under a variety of names since 1981.
 .
 This package contains files common firebird server, client and user utilities.
 .
 These include the message file (firebird.msg), support scripts as well as
 configuration files in /etc/firebird/3.0.
 .
 Please refer to the firebird3.0-server or firebird3.0-utils packages for more
 information about Firebird in general.

Package: firebird-dev
Section: libdevel
Architecture: all
Conflicts: firebird2-dev, firebird2.0-dev, firebird2.1-dev, firebird2.5-dev
Replaces: firebird2-dev, firebird2.0-dev, firebird2.1-dev, firebird2.5-dev
Depends: libfbclient2 (>= ${source:Version}),
 libib-utili (>= ${source:Version}),
 ${misc:Depends},
 firebird3.0-common-doc (= ${source:Version})
Suggests: firebird3.0-examples
Description: Development files for Firebird
 This package contains C header files for Firebird. They are useful if you
 compile programs that use the firebird client to talk to firebird servers.
 .
 Please refer to the firebird3.0-server and firebird3.0-utils packages for
 more information about Firebird in general.

Package: firebird3.0-examples
Section: doc
Architecture: all
Depends: ${misc:Depends},
 firebird3.0-common-doc (= ${source:Version})
Recommends: firebird3.0-dev
Description: Examples for Firebird - an RDBMS based on InterBase 6.0 code
 The examples included in this package are provided as samples and are also
 used by Firebird's testing suite (TCS). The examples are in the form
 of .h, .c, .e, .fdb and .gbk files.
 .
 Please refer to the firebird3.0-server and firebird3.0-utils packages for
 more information about Firebird in general.

Package: firebird3.0-doc
Section: doc
Architecture: all
Depends: ${misc:Depends},
 firebird3.0-common-doc (= ${source:Version})
Description: Documentation files for firebird database version 3.0
 Various documents for firebird 3.0. These include the release notes, what's
 new in firebird 3.0, quick start guide, upgrade guide, list of ISQL
 enhancements etc.

Package: firebird3.0-common-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: copyright, licnesing and changelogs of firebird3.0
 This package contains the copyright and licensing information of firebird3.0,
 as well as the upstream changelog.
 .
 Due to the size of the upstream change log and copyright/licensing summary,
 keeping them in a separate package saves space on mirrors and when installing
 firebird3.0 packages.
 .
 Please refer to the firebird3.0-server or firebird3.0-utils packages for more
 information about Firebird database in general.

Package: firebird3.0-dbg
Section: debug
Priority: extra
Architecture: any
Depends: ${misc:Depends},
 firebird3.0-common-doc (= ${source:Version}),
 firebird3.0-server (= ${binary:Version}) | firebird3.0-utils (= ${binary:Version}) | libfbclient2 (= ${binary:Version})
Provides: firebird-dbg
Conflicts: firebird-dbg
Description: collected debug symbols for firebird3.0
 This package contains extracted debug symbols for firebird3.0 server, client
 library and user utilities, which are stripped from the other packages. Debug
 symbols are useful when tracing a problem like a segmentation fault in some
 firebird binary.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode. 
#export DH_VERBOSE=1

FB_MAJOR:= $(shell awk '/FB_MAJOR_VER/ { v=$$3; gsub("\"", "", v); print v}' < src/jrd/build_no.h )
FB_MINOR:= $(shell awk '/FB_MINOR_VER/ { v=$$3; gsub("\"", "", v); print v}' < src/jrd/build_no.h )
FB_REV	:= $(shell awk '/FB_REV_NO/    { v=$$3; gsub("\"", "", v); print v}' < src/jrd/build_no.h )
FB_VER	:= $(FB_MAJOR).$(FB_MINOR)
FB_FULL_VER:= $(FB_VER).$(FB_REV)

CLIENT_SOVER=2
UTIL_SOVER=

ifndef FB_MAJOR
$(error FB_MAJOR not defined)
else ifndef FB_MINOR
$(error FB_MINOR not defined)
else ifndef FB_REV
$(error FB_REV not defined)
else ifndef FB_VER
$(error FB_VER not defined)
else ifndef FB_FULL_VER
$(error FB_FULL_VER not defined)
else ifndef CLIENT_SOVER
$(error CLIENT_SOVER not defined)
endif

# Use the following lines to set the compiler if
# the default Debian one can't be used (or you want to try
# the bleeding edge)
#export CC=gcc-4.3
#export CXX=g++-4.3
#export CPP=cpp-4.3
#export CXXPP=cpp-4.3


export DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
export DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
	confflags += --build $(DEB_HOST_GNU_TYPE)
else
	confflags += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
endif

DOC=/usr/share/doc/firebird${FB_VER}-common-doc
ULFB=/usr/lib/firebird/${FB_VER}
USFB=/usr/share/firebird/${FB_VER}
VAR=/var/lib/firebird/${FB_VER}
RUN=/var/run/firebird/${FB_VER}

confflags += --disable-rpath --with-gpre-cobol \
	     --with-system-editline --prefix=/usr --with-fbsbin=/usr/sbin \
	     --with-fbconf=/etc/firebird/${FB_VER} --with-fbdoc=${DOC} \
	     --with-fbudf=${ULFB}/UDF --with-fbsample=${DOC}/examples \
	     --with-fbsample-db=${DOC}/examples/empbuild \
	     --with-fbhelp=${VAR}/system --with-fbintl=${ULFB}/intl \
	     --with-fbmisc=${ULFB}/misc --with-fbsecure-db=${VAR}/system \
	     --with-fbmsg=${USFB} --with-fblog=/var/log --with-fbglock=${RUN} \
	     --with-fblogfilename=firebird$(FB_VER).log \
	     --with-fbplugins=${ULFB}/plugins

# see #575564
export FIREBIRD_LOCK=$(CURDIR)/debian/tmp-lock

# Packaging is split into several packages:
# * firebirdVV-server (incl libengineXX)
# * libfbclient2
# * libib-util
# * firebirdVV-utils
# * firebirdVV-common (common parts to client and utils)
# * firebirdVV-common-doc (big copyright and changelog one place)
# * firebirdVV-doc
# * firebirdVV-examples
# * firebird-dev

autogen: autogen-stamp
autogen-stamp:
	NOCONFIGURE=1 sh autogen.sh
	touch $@

.PHONY: configure
configure: configure-stamp
configure-stamp: autogen-stamp
	@echo ================================
	@echo ==== Starting configuration ====
	@echo ================================
	dh_testdir

	-sh debian/clean-after-build.sh

	chmod u+x ./configure
	CFLAGS= CXXFLAGS= ./configure $(confflags)

	touch $@

.PHONY: build
build: build-stamp
build-stamp: build-manuals build-server
	touch $@

MANUALS_BASE = isql-fb gbak gfix gpre gsec fbstat qli nbackup \
	       fbsvcmgr fbtracemgr fbguard \
	       fb_lock_print firebird
MANUALS = $(addprefix debian/man/,$(addsuffix .1,$(MANUALS_BASE)))

.PHONY: build-manuals
build-manuals: $(MANUALS)

%.1 : %.pod
	pod2man -c "Firebird documentation" --release "Firebird $(FB_VER)"  $< > $@

%.1 : %.sgml
	docbook-to-man $< > $@

.PHONY: build-server
build-server: build-server-stamp
build-server-stamp: configure-stamp
	echo Starting build
	dh_testdir
	[ -d $(FIREBIRD_TMP) ] || mkdir $(FIREBIRD_TMP)
	$(MAKE) QUIET=1

	rm -rf ./debian/firebird-image
	#fakeroot $(MAKE) -C gen -f Makefile.install buildRoot
	#mv ./gen/buildroot ./debian/firebird-build
	cp -a ./gen/Release/firebird debian/firebird-image

	echo "Built image contents"
	cd debian/firebird-image && ls -lR

	touch $@

.PHONY: clean
clean:
	dh_testdir
	
	sh debian/clean-after-build.sh
	
	rm -f $(MANUALS)
	
	rm -f 	build-stamp build-server-stamp configure-stamp \
		autogen-stamp
	
	# re-generated in autogen target
	rm -f builds/make.new/config/config		\
	      builds/make.new/config/config.guess	\
	      builds/make.new/config/config.h.in	\
	      builds/make.new/config/config.sub 	\
	      builds/make.new/config/ltmain.sh		\
	      builds/make.new/config/install-sh		\
	      aclocal.m4				\
	      configure
	
	rm -rf	debian/firebird-image
	
	debconf-updatepo
	
	dh_clean
	
	@echo FB_MAJOR = $(FB_MAJOR)
	@echo FB_MINOR = $(FB_MINOR)
	@echo FB_REV   = $(FB_REV)
	@echo FB_VER   = $(FB_VER)
	@echo FB_FULL_VER = $(FB_FULL_VER)
	@echo CLIENT_SOVER= $(CLIENT_SOVER)
	@echo UTIL_SOVER= $(UTIL_SOVER)

.PHONY: install
install: DH_OPTIONS=
install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	sh debian/make_packages.sh

.PHONY: binary-indep
binary-indep: install
	dh_testdir -i
	dh_testroot -i
	dh_installdocs -p firebird$(FB_VER)-common-doc
	dh_installdocs -Xchangelog -Xcopyright -p firebird$(FB_VER)-doc
	dh_installman -i
	dh_installexamples -i
	dh_installlogrotate -i --name firebird$(FB_VER)
	dh_installchangelogs ChangeLog -p firebird$(FB_VER)-common-doc
	dh_lintian -i
	dh_link -i
	dh_compress -i
	dh_fixperms -i

	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i


.PHONY: binary-arch
# Build architecture-dependent files here.
binary-arch: install
	dh_testdir -a
	dh_testroot -a
	dh_installdebconf -a
	dh_installexamples -a
	dh_installmenu -a
	dh_installinit -pfirebird$(FB_VER)-server --name=firebird$(FB_VER)
	dh_installcron -a
	dh_installman -a
	dh_installinfo -a
	dh_installlogrotate -a --name firebird$(FB_VER)
	dh_lintian -a
	dh_strip -a --dbg-package firebird$(FB_VER)-dbg
	dh_link -a -A
	dh_compress -a
	dh_fixperms -a

	dh_makeshlibs -p libfbclient$(CLIENT_SOVER) -V'libfbclient$(CLIENT_SOVER) (>= $(FB_FULL_VER)~)'
	dh_makeshlibs -p libib-util$(UTIL_SOVER) -V'libib-util$(UTIL_SOVER) (>= $(FB_FULL_VER)~)'

	dpkg-gensymbols -plibfbclient$(CLIENT_SOVER) -Pdebian/libfbclient$(CLIENT_SOVER)
	dpkg-gensymbols -plibib-util$(UTIL_SOVER) -Pdebian/libib-util$(UTIL_SOVER)

	dh_installdeb -a
	dh_shlibdeps -a -X /plugins/
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

.PHONY: binary
binary: binary-indep binary-arch

.PHONY: get-orig-source
get-orig-source:
	uscan

=== debian/watch ===
# watch control file for uscan
# you can run the "uscan" command
# to check for upstream updates and more.
# Full-site-with-pattern  [Version  [Action]]

version=3
opts="dversionmangle=s/(?:\.ds\d+)$//,uversionmangle=s/-(?=\D)/~/g" \
  http://www.firebirdsql.org/download/prerelease/source/ \
  .*Firebird-(3\.0\..+)\.tar\.bz2 debian sh debian/repack.sh
opts="dversionmangle=s/(?:\.ds\d+)$//,uversionmangle=s/-(?=\D)/~/g,uversionmangle=s/-(?=Unstable)/~~/g" \
  http://www.firebirdsql.org/download/snapshot_builds/linux/fb3.0/ \
  .*Firebird-(3\.0\..+)\.tar\.bz2 debian sh debian/repack.sh
opts="dversionmangle=s/(?:\.ds\d+)$//,uversionmangle=s/-(?=\D)/~/g" \
  http://sf.net/firebird/[Ff]irebird-(3\.0\..*).tar.bz2 \
  debian sh debian/repack.sh

## firebird3.0 3.0.1.32609.ds4

=== debian/changelog ===
firebird3.0 (3.0.1.32609.ds4-14) unstable; urgency=high

  * Apply commit 56e9a73c168 from upstream B3_0_Release branch
    fixing authenticated remote execution vulnerability (CVE-2017-6369,
    CORE-5474)
    Closes: #858644

 -- Damyan Ivanov <dmn@debian.org>  Sat, 25 Mar 2017 16:07:07 +0000

firebird3.0 (3.0.1.32609.ds4-13) unstable; urgency=medium

  * Add Danish debconf translation by Joe Dalton (Closes: #850854)
  * Added patch from upstream B3_0_Release branch fixing a rare segfault
    during engine unload (Closes: #846392)
  * Revert "rules: make the sample table browsing failures non-fatal"

 -- Damyan Ivanov <dmn@debian.org>  Sat, 14 Jan 2017 15:56:28 +0000

firebird3.0 (3.0.1.32609.ds4-12) unstable; urgency=medium

  * Drop the PIDFile= line from firebird3.0.service
  * rules: invoke dh_systemd_enable to enable the firebird3.0 service upon
    -server package installation

 -- Damyan Ivanov <dmn@debian.org>  Tue, 06 Dec 2016 19:26:44 +0000

firebird3.0 (3.0.1.32609.ds4-11) unstable; urgency=medium

  * Revert "Change runtime directory from /var/run/firebird3.0 to
    /var/run/firebird/3.0"
  * functions.sh: RUN="/var/run/firebird3.0"  (no sub-dir)
  * rules: make the sample table browsing failures non-fatal

 -- Damyan Ivanov <dmn@debian.org>  Wed, 30 Nov 2016 21:02:33 +0000

firebird3.0 (3.0.1.32609.ds4-10) unstable; urgency=medium

  * Change default bind address from '[::1]' to 'localhost'
  * Change runtime directory from /var/run/firebird3.0 to
    /var/run/firebird/3.0

 -- Damyan Ivanov <dmn@debian.org>  Tue, 15 Nov 2016 08:24:29 +0000

firebird3.0 (3.0.1.32609.ds4-9) unstable; urgency=medium

  * quote all strings in debian/make_packahes.sh
  * make the server listen only on the loopback interface by default

 -- Damyan Ivanov <dmn@debian.org>  Fri, 11 Nov 2016 08:56:40 +0000

firebird3.0 (3.0.1.32609.ds4-8) unstable; urgency=medium

  * rewrite manuals of isql-fb, gbak, gfix and gsec from SGML to POD
  * drop the manual of qli, which is not part of Firebird anymore
  * drop docbook-to-man from build-dependencies, no longer used
  * add --with-bin=/usr/bin flag to configure invocation
    makes fb_config --bindir match the reality
  * add manual for fb_config

 -- Damyan Ivanov <dmn@debian.org>  Thu, 20 Oct 2016 08:07:06 +0000

firebird3.0 (3.0.1.32609.ds4-7) unstable; urgency=medium

  * remove debian/fdb-r15y-prune.d on clean
  * rules: use := where possible
  * rules: rearrange targets and stamps to avoid touching build-stamp when
    satisfying the binary target
  * rules: enable raw device support only on linux
    Fixes FTBFS on kfreebsd
  * add patch by John Paul Adrian Glaubitz fixing garbage output by gpre and
    isql caused by linkage issues on mips64el, alpha and m68k
    (Closes: #840666)
  * Add patch by John Paul Adrian Glaubitz adding support for m68k
    (Closes: #840684)

 -- Damyan Ivanov <dmn@debian.org>  Thu, 13 Oct 2016 20:31:51 +0000

firebird3.0 (3.0.1.32609.ds4-6) unstable; urgency=medium

  * add RuntimeDirectory= to server's service files
    fixes firebird3.0-server startup errors
  * use and build-depend on 'rename' package instead of perl-provided prename
  * temporary directory is /tmp/firebird
  * doc-base: let all Titles start with 'Firebird 3.0'
  * doc-base: include all text docs
  * turn echo on when verifying pruned database

 -- Damyan Ivanov <dmn@debian.org>  Wed, 12 Oct 2016 08:57:51 +0000

firebird3.0 (3.0.1.32609.ds4-5) unstable; urgency=medium

  * Verify and apply suggestions from the multi-arch hinter
    -doc and -examples become M-A: foreign
    -server-core becomes M-A: same
  * build fdb-r15y-prune with a separate Makefile
    this allows including compiler flags from gen/make.platform without
    parsing its content by hand, which was broken on some architectures due
    to unexpected content
  * test resulting example database after pruning

 -- Damyan Ivanov <dmn@debian.org>  Tue, 11 Oct 2016 08:54:46 +0000

firebird3.0 (3.0.1.32609.ds4-4) unstable; urgency=medium

  * symlink stuff in /usr/lib/<triplet>/firebird/3.0 to match fb_config output
  * Mark firebird3.0-common as Multi-Arch: foreign

 -- Damyan Ivanov <dmn@debian.org>  Mon, 10 Oct 2016 10:08:12 +0000

firebird3.0 (3.0.1.32609.ds4-3) unstable; urgency=medium

  * Add Multi-Arch headers to libfbclient2, libib-util and
    firebird3.0-common-doc
  * integrate fdb-r15y-prune from 2.5
    + compare DB ODS version with the one the tool is compiled against, not a
      fixed number
    + reset pag_generation (last changing transaction ID) and pag_reserved for
      all page types
    + more information about data pages
  * Upload to unstable

 -- Damyan Ivanov <dmn@debian.org>  Fri, 07 Oct 2016 07:00:01 +0000

firebird3.0 (3.0.1.32609.ds4-2) experimental; urgency=medium

  * d/rules: call configure with arch-specific --prefix
  * d/rules: build --with-fbconf=${ULFB} and symlink *.conf there
    ($ULFB = /usr/lib/<triplet>/firebird/3.0)
  * d/rules: rely on the environment for passing compiler flags
  * add compiler flags to make the build pass with gcc6
    -std=gnu++98
    -fno-lifetime-dse
    -fno-delete-null-pointer-checks
    -fno-strict-aliasing
  * amend honour-buildflags.patch to add CFLAGS when building btyacc
  * use proper versioned dependency on lsb-base for /lib/lsb/init-functions
    (thanks, lintian)

 -- Damyan Ivanov <dmn@debian.org>  Wed, 05 Oct 2016 11:00:35 +0000

firebird3.0 (3.0.1.32609.ds4-1) experimental; urgency=medium

  * remove symlinks in /usr/lib/firebird/3.0
    instead of mimicking a "standard layout" under /usr/lib/firebird/3.0
    (a non-standard location to begin with), rely on fb_config telling
    potential users where things are.
    As a side effect Closes: #838365 -- broken symlink to aliases.conf
    (and aliases.conf is gone in 3.0 anyway)
  * adopt multi-arch paths under /usr/lib
  * New upstream version 3.0.1.32609.ds4
    + drop two files from d/copyright, gone upstream
    + drop three patches released upstream


=== debian/control ===
--- 
+++ 
@@ -7,19 +7,44 @@
  autoconf,
  automake,
  bison,
- debhelper (>= 7),
- docbook-to-man,
+ debhelper (>= 9.20151219~),
+ debhelper (>= 9.20160709~) | dh-systemd,
  gawk,
  libatomic-ops-dev (>= 1.2+cvs20091005),
+ libboost-dev,
  libedit-dev,
  libicu-dev,
+ libtommath-dev,
  libtool,
- po-debconf
+ po-debconf,
+ procmail,
+ rename,
+ zlib1g-dev,
 Build-Conflicts: autoconf2.13, automake1.4
-Standards-Version: 3.9.2
-Vcs-Git: git://git.debian.org/git/pkg-firebird/3.0.git
-Vcs-Browser: http://git.debian.org/?p=pkg-firebird/3.0.git;a=summary
+Standards-Version: 3.9.8
+Vcs-Git: https://anonscm.debian.org/git/pkg-firebird/3.0.git
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-firebird/3.0.git
 Homepage: http://firebirdsql.org/
+
+Package: firebird3.0-server-core
+Architecture: any
+Multi-Arch: same
+Breaks: firebird3.0-server (<< 3.0.0.32483.ds4-6~)
+Replaces: firebird3.0-server (<< 3.0.0.32483.ds4-6~)
+Depends: ${shlibs:Depends}, ${misc:Depends},
+ firebird3.0-common (= ${source:Version}),
+ firebird3.0-common-doc (= ${source:Version})
+Suggests: firebird3.0-server
+Description: Firebird Server - engine core
+ Firebird is a relational database offering many ANSI SQL-99 features that
+ runs on Linux, Windows, and a variety of Unix platforms. Firebird offers
+ excellent concurrency, high performance, and powerful language support
+ for stored procedures and triggers. It has been used on production systems
+ under a variety of names since 1981.
+ .
+ This package contains the server engine and support libraries. The rest of
+ the binaries needed for running a full-featured firebird server are in the
+ firebird3.0-server package.
 
 Package: firebird3.0-server
 Architecture: any
@@ -27,10 +52,11 @@
 Conflicts: firebird-server,
  firebird2.5-server-common,
  firebird2.1-super, firebird2.1-classic, firebird2.1-server-common,
- firebird2.0-classic, firebird2.0-super, firebird2.0-server-common
 Depends: adduser, ${shlibs:Depends}, firebird3.0-common (= ${source:Version}),
+ firebird3.0-server-core (= ${binary:Version}),
  firebird3.0-utils (= ${binary:Version}),
- lsb-base, ${misc:Depends}, debconf (>= 1.4.69),
+ lsb-base (>= 3.0-6),
+ ${misc:Depends}, debconf (>= 1.4.69),
  firebird3.0-common-doc (= ${source:Version})
 Recommends: libib-util
 Suggests: firebird3.0-doc
@@ -47,24 +73,15 @@
  connection has its own page cache. The two other operation modes -- "classic"
  (separate process/cache for each connection; started from the internet
  super-server inetd or xinetd) and "super" (single-threaded server process with
- shared cache beteen connections) are also available via configuration options.
- .
- This package contains the 3.0 branch of Firebird and is meant for the
- experimental Debian distribution, due to the high pace of ongoing upstream
- development. Its goal is to provide easy testing of the new features of
- Firebird and to have early exposure of the packaging helping to discover any
- problems.
- .
- Be aware that the ODS (on-disk structure) hasn't been finalized yet, so
- databases could be incompatible between different package versions and you'll
- have to either recreate them or migrate them via backup/restore.
+ shared cache between connections) are also available via configuration options.
 
 Package: firebird3.0-utils
 Architecture: any
 Provides: firebird-utils
-Conflicts: firebird-utils, firebird2.5-common,
+Conflicts: firebird-utils,
+ firebird2.5-common, firebird2.5-server-common,
  firebird2.1-super, firebird2.1-classic, firebird2.1-common,
- firebird2.0-classic, firebird2.0-super, firebird2.0-common
+ firebird2.5-super, firebird2.5-classic-common
 Depends: ${shlibs:Depends}, firebird3.0-common (= ${source:Version}),
  ${misc:Depends}, 
  firebird3.0-common-doc (= ${source:Version})
@@ -88,6 +105,7 @@
 Package: libfbclient2
 Section: libs
 Architecture: any
+Multi-Arch: same
 Depends: ${shlibs:Depends}, firebird3.0-common (= ${source:Version}),
  ${misc:Depends},
  firebird3.0-common-doc (= ${source:Version})
@@ -98,15 +116,12 @@
  for stored procedures and triggers. It has been used on production systems
  under a variety of names since 1981.
  .
- This package contains the client library required to connect to Firebird. It
- works with Firebird and commercial InterBase servers.
- .
- It uses TCP to connect to remote databases and file-level access for local
- databases.
+ This package contains the client library required to connect to Firebird.
 
 Package: libib-util
 Section: libs
 Architecture: any
+Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends},
  firebird3.0-common-doc (= ${source:Version})
 Description: Firebird UDF support library
@@ -121,6 +136,7 @@
 
 Package: firebird3.0-common
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends},
  firebird3.0-common-doc (= ${source:Version})
 Description: common files for firebird 3.0 server, client and utilities
@@ -132,19 +148,19 @@
  .
  This package contains files common firebird server, client and user utilities.
  .
- These include the message file (firebird.msg), support scripts as well as
- configuration files in /etc/firebird/3.0.
+ These include the support scripts as well as configuration files in
+ /etc/firebird/3.0.
  .
  Please refer to the firebird3.0-server or firebird3.0-utils packages for more
  information about Firebird in general.
 
 Package: firebird-dev
 Section: libdevel
-Architecture: all
-Conflicts: firebird2-dev, firebird2.0-dev, firebird2.1-dev, firebird2.5-dev
-Replaces: firebird2-dev, firebird2.0-dev, firebird2.1-dev, firebird2.5-dev
+Architecture: any
+Conflicts: firebird2-dev, firebird2.1-dev, firebird2.5-dev
+Replaces: firebird2-dev, firebird2.1-dev, firebird2.5-dev
 Depends: libfbclient2 (>= ${source:Version}),
- libib-utili (>= ${source:Version}),
+ libib-util (>= ${source:Version}),
  ${misc:Depends},
  firebird3.0-common-doc (= ${source:Version})
 Suggests: firebird3.0-examples
@@ -158,6 +174,7 @@
 Package: firebird3.0-examples
 Section: doc
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends},
  firebird3.0-common-doc (= ${source:Version})
 Recommends: firebird3.0-dev
@@ -172,6 +189,7 @@
 Package: firebird3.0-doc
 Section: doc
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends},
  firebird3.0-common-doc (= ${source:Version})
 Description: Documentation files for firebird database version 3.0
@@ -182,8 +200,9 @@
 Package: firebird3.0-common-doc
 Section: doc
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
-Description: copyright, licnesing and changelogs of firebird3.0
+Description: copyright, licensing and changelogs of firebird3.0
  This package contains the copyright and licensing information of firebird3.0,
  as well as the upstream changelog.
  .
@@ -193,18 +212,3 @@
  .
  Please refer to the firebird3.0-server or firebird3.0-utils packages for more
  information about Firebird database in general.
-
-Package: firebird3.0-dbg
-Section: debug
-Priority: extra
-Architecture: any
-Depends: ${misc:Depends},
- firebird3.0-common-doc (= ${source:Version}),
- firebird3.0-server (= ${binary:Version}) | firebird3.0-utils (= ${binary:Version}) | libfbclient2 (= ${binary:Version})
-Provides: firebird-dbg
-Conflicts: firebird-dbg
-Description: collected debug symbols for firebird3.0
- This package contains extracted debug symbols for firebird3.0 server, client
- library and user utilities, which are stripped from the other packages. Debug
- symbols are useful when tracing a problem like a segmentation fault in some
- firebird binary.
